//+------------------------------------------------------------------+
//|                                           ChanExpert.mq4         |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                      mail_to: tradertobe@gmail.com               |
//|                      http://forum.mql4.com/ru/  Paticipant "more"|
//+------------------------------------------------------------------+
/*
extern string HostName            = "Tradertobe"; 
extern int    HostExpertMagic     = 10; 
extern int    WaitForReplyTimeout = 10 ; // in seconds
*/
extern int    HostExpertMagic     = 10; 
extern int    WaitForReplyTimeout = 10 ; // in seconds

//*****************************************************************************
#include <ChanExpertImport.mq4>
//*****************************************************************************
//*****************************************************************************
int _ExpertChansTotal;    // Total number of Chan
int _ExpertChansConnect;  // CONNECT_TYPE Chan number   
int _ExpertChansAccept;   // ACCEPT_TYPE  Chan number   
// ,           
int      _ChanTicket[];             
int      _ChanPeerTicket[];   
     
int      _ChanHostInetAddr[];          
string   _ChanHostIP[];          
string   _ChanHostName[];          
int      _ChanHostExpertMagic[];  
        
int      _ChanPeerInetAddr[];          
string   _ChanPeerIP[];          
string   _ChanPeerName[];          
int      _ChanPeerExpertMagic[]; 
        
int      _ChanPosition[];          
int      _ChanType[];            
int      _ChanOpenTime[];    
string   _ChanComment[];    
int      _ChanBufInt   [][CHAN_BUFINTSIZE];    
double   _ChanBufDouble[][CHAN_BUFDOUBLESIZE];    
//*****************************************************************************
#include <ChanExpertGetAll.mq4>
//*****************************************************************************
extern bool ExpertEnable = true;
#define     barscount  300
double      IndBuf_0_Send[barscount];
int         Ret,Ret1,Ret2,i;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
    Ret = ChanExpertStartup(
          HostName,
          WaitForReplyTimeout
         );
    if (!Ret) 
    {
         Comment("ChanExpertStartup failed.Expert stopped."+"\n"+
                 "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
          ExpertEnable = false; return;
    }
    else
          Comment("ChanExpertStartup OK!...");
          
    Ret = ChanExpertInit(HostExpertMagic);
    if (!Ret) 
    {
          Comment("ChanExpertInit(HostExpertMagic) failed.Expert stopped."+"\n"+
                  "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
          ExpertEnable = false; return;
    }
    else
          Comment("ChanExpertInit(HostExpertMagic) OK! Expert is running...");
    return;
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
    Ret = ChanExpertDeInit(HostExpertMagic);
    if (!Ret) 
    {
          Comment("ChanExpertDeInit(HostExpertMagic) failed"+"\n"+
                  "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
    }
    else
          Print("ChanExpertDeInit(HostExpertMagic) OK!");
    return(0);
}
//+------------------------------------------------------------------+
//| expert ticks proccesing function                                 |
//+------------------------------------------------------------------+
int start()
{ 
    if (!ExpertEnable) return;
    
    if (!ChanExpertGetAll(HostExpertMagic,ACCEPT_TYPE))
    {
         if (ChanGetLastUSERError() == IN_OUT_CONTEXT_BUSY)
         {
              Print("ChanExpertGetAll(HostExpertMagic,ACCEPT_TYPE): ChanGetLastUSERError() == IN_OUT_CONTEXT_BUSY");  
              return;
         }
         Print("ChanExpertGetAll(HostExpertMagic,ACCEPT_TYPE) failed..."+"\n"+
                  "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());  
         return;           
         ExpertEnable = false; return;
    }
    Print("_ExpertChansAccept =", _ExpertChansAccept);
    
    for (i = 0; i < _ExpertChansAccept; i++)
    {
/*    
         Print("_ChanTicket[",i,"]    =", _ChanTicket[i]);
         Print("_ChanComment[",i,"]   =", _ChanComment[i]);
         Print("_ChanBufInt[",i,"][0] =", _ChanBufInt[i][0]);
*/  
//double iBands( 	string symbol, int timeframe, int period, int deviation, int bands_shift, int applied_price, int mode, int shift)
int period        = 20;          //    .
int deviation 	   = 2;           //   .
int bands_shift 	= 0;           //    .
int applied_price = PRICE_CLOSE; // .      .
/*
         for (int j = 0; j < barscount; j++)
         {
              IndBuf_0_Send[j] = iCustom(_ChanComment[i],_ChanBufInt[i][0],IndName,0,j);
         }
*/         
         int k = barscount/3-1;
         for (int j = barscount-1; k >= 0; j -=3)
         {
              IndBuf_0_Send[j-0] = iBands(_ChanComment[i],_ChanBufInt[i][0],  period,deviation,bands_shift,applied_price, MODE_UPPER, k);
              IndBuf_0_Send[j-1] = iMA(   _ChanComment[i],_ChanBufInt[i][0], period,          bands_shift,MODE_SMA,applied_price,k);
              IndBuf_0_Send[j-2] = iBands(_ChanComment[i],_ChanBufInt[i][0], period,deviation,bands_shift, applied_price, MODE_LOWER,k);
              k--;
         }
//       Print("Before ChanSendDouble()");
         Ret = ChanSendDouble(_ChanTicket[i],IndBuf_0_Send,barscount);
//       Print("After ChanSendDouble()");
         if (!Ret)
         {
              if (ChanGetLastUSERError() == IN_OUT_CONTEXT_BUSY)
              {
                   Print("ChanSendDouble(_ChanTicket[",i,"],IndBuf_0_Send,barscount): ChanGetLastUSERError() == IN_OUT_CONTEXT_BUSY");  
                   return;
              }
              Print("ChanSendDouble(_ChanTicket[",i,"],IndBuf_0_Send,barscount) failed..."+"\n"+
                      "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());  
              continue;          
              ExpertEnable = false; return;
         }
         Print("ChanSendDouble(_ChanTicket[",i,"],IndBuf_0_Send,barscount) OK.");
         continue;
    } // for (i = 0; i < _ExpertChansAccept; i++) {
    return;
} // int start() {
//***************************************************************************************************